
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>std::bind技术内幕 / iVAN</title>

    <meta name="description" content="std::bind技术内幕 引子 最近群里比较热闹,大家都在山寨c++11的std::bind,三位童孩分别实现了自己的bind,代码分别在这里: 木头云的实现:连接稍后补上. mr.li的实现:https://code.google.com/p/y-code-svn/source/browse/ null的实现:http://www.cnblogs.com/xusd-null/p/3693817.html 这些实现思路和ms stl的std::bind的实现思路是差不多的,只是在实现的细节上有些不同.个人觉得木头云的实现">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">std::bind技术内幕</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>引子</p>
<p>最近群里比较热闹，大家都在山寨c++11的std::bind，三位童孩分别实现了自己的bind，代码分别在这里：</p>
<p>木头云的实现：连接稍后补上。</p>
<p>mr.li的实现：https://code.google.com/p/y-code-svn/source/browse/</p>
<p>null的实现：http://www.cnblogs.com/xusd-null/p/3693817.html</p>
<p>这些实现思路和ms stl的std::bind的实现思路是差不多的，只是在实现的细节上有些不同。个人觉得木头云的实现更简洁，本文中的简单实现也是基于木头云的bind之上的，在此表示感谢。下面我们来分析一下bind的基本原理。</p>
<p>bind的基本原理</p>
<p>bind的思想实际上是一种延迟计算的思想，将可调用对象保存起来，然后在需要的时候再调用。而且这种绑定是非常灵活的，不论是普通函数、函数对象、还是成员函数都可以绑定，而且其参数可以支持占位符，比如你可以这样绑定一个二元函数auto f = bind(&amp;func, _1, _2);，调用的时候通过f(1,2)实现调用。关于bind的用法更多的介绍可以参考我博客中介绍：http://www.cnblogs.com/qicosmos/p/3302144.html。</p>
<p>要实现一个bind需要解决两个问题，第一个是保存可调用对象及其形参，第二个是如何实现调用。下面来分析如何解决这两个问题。</p>
<p>保存可调用对象</p>
<p>实现bind的首先要解决的问题是如何将可调用对象保存起来，以便在后面调用。要保存可调用对象，需要保存两个东西，一个是可调用对象的实例，另一个是可调用对象的形参。保存可调用对象的实例相很简单，因为bind时直接要传这个可调用对象的，将其作为一个成员变量即可。而保存可调用对象的形参就麻烦一点，因为这个形参是变参，不能直接将变参作为成员变量。如果要保存变参的话，我们需要用tuple来将变参保存起来。</p>
<p>可调用对象的执行</p>
<p>bind的形参因为是变参，可以是0个，也可能是多个，大部分情况下是占位符，还有可能占位符和实参都有。正是由于bind绑定的灵活性，导致我们不得不在调用的时候需要找出哪些是占位符，哪些是实参。如果某个一参数是实参我们就不处理，如果是占位符，我们就要将这个占位符替换为对应的实参。比如我们绑定了一个三元函数：auto f = bind(&amp;func, _1, 2, _2);调用时f(1,3);由于绑定时有三个参数，一个实参，两个占位符，调用时传入了两个实参，这时我们就要将占位符_1替换为实参1，占位符_2替换为实参3。这个占位符的替换需要按照调用实参的顺序来替换，如果调用时的实参个数比占位符要多，则忽略多余的实参。</p>
<p>调用的实参，我们也会先将其转换为tuple，用于在后面去替换占位符时，选取合适的实参。</p>
<p>bind实现的关键技术</p>
<p>将tuple展开为变参</p>
<p>前面讲到绑定可调用对象时，将可调用对象的形参（可能含占位符）保存起来，保存到tuple中了。到了调用阶段，我们就要反过来将tuple展开为可变参数，因为这个可变参数才是可调用对象的形参，否则就无法实现调用了。这里我们会借助于一个整形序列来将tuple变为可变参数，在展开tuple的过程中我们还需要根据占位符来选择合适实参，即占位符要替换为调用实参。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 19:51:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e5%8f%82%e6%95%b0/" title="参数">参数</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/%e5%bd%a2%e5%8f%82/" title="形参">形参</a>, <a href="https://www.iamivan.net/tag/bind/" title="BIND">BIND</a>, <a href="https://www.iamivan.net/tag/binding/" title="binding">binding</a>, <a href="https://www.iamivan.net/tag/%e5%8f%af%e5%8f%98%e5%8f%82/" title="可变参">可变参</a>, <a href="https://www.iamivan.net/tag/%e5%8d%a0%e4%bd%8d%e5%8f%82%e6%95%b0/" title="占位参数">占位参数</a>, <a href="https://www.iamivan.net/tag/%e5%8d%a0%e4%bd%8d%e9%97%ae%e9%a2%98/" title="占位问题">占位问题</a>, <a href="https://www.iamivan.net/tag/%e5%ae%9e%e5%8f%82/" title="实参">实参</a>, <a href="https://www.iamivan.net/tag/%e5%ae%9e%e5%8f%82-%e5%bd%a2%e5%8f%82/" title="实参 形参">实参 形参</a>, <a href="https://www.iamivan.net/tag/bind-dlz/" title="bind dlz">bind dlz</a>, <a href="https://www.iamivan.net/tag/bind%e6%96%b9%e6%b3%95%e5%8e%9f%e7%90%86/" title="bind方法原理">bind方法原理</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>std::bind技术内幕的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3k0Op.html" rel="bookmark">COM技术内幕（笔记）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				COM--到底是什么?--COM标准的要点介绍,它被设计用来解决什么问题?基本元素的定义--COM术语以及这些术语的含义.使用和处理COM对象--如何创建.使用和销毁COM对象.基本接口--描述IUnknown基本接口及其方法. 掌握串的处理--在COM代码中如何处理串.应用COM技术--例子代码,举例说明本文所讨论的所有概念. 处理HRESULT--HRESULT类型描述,如何监测错误及成功代码. COM--到底是什么?     简单地说,COM是一种跨应用和语言共享二进制代码的方法.与C++			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2PQqp.html" rel="bookmark">mysql 5 mysql 5 技术内幕</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql 5 mysql 5 技术内幕: http://www.kitebird.com/mysql-book/4ed.php			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyDK4b.html" rel="bookmark">Flash鼠绘技术内幕完全接触</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.鼠绘技术内幕完全接触-概述篇 [2005-02-27]     2.鼠绘技术内幕完全接触-动物篇 [2005-02-27]     3.鼠绘技术内幕完全接触-环境背景篇 [2005-02-27]     4.鼠绘技术内幕完全接触--效果篇 [2005-02-27]     5.鼠绘技术内幕完全接触-植物篇 [2005-02-27]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmwY7b.html" rel="bookmark">鼠绘技术内幕完全接触－动物篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				动物是生态世界中重要的组成部分,在卡通绘画中,动物也是重要的组成部分,动物的千姿百态被设计师们充分的发挥利用,并注入了人类的思想感情,使得动物也变得和人一样感情丰富,幽默风趣.而且,在卡通的世界里,动物过着人一样的生活,和人一样也有忠奸善恶.喜怒哀乐,让原本有趣的卡通世界更加丰富多彩. 在讲述鼠绘动物技术内幕之前,先教大家几个学习动物鼠绘的方法: 集思广益:在动画世界里,动物占有相当大的比例,所以这方面成功的例子很多,大家可以收集并分析;了角同一种动物的不同种表现方法,以便更好的掌握它的形象特征			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQEoob.html" rel="bookmark">&period;NET编译技术内幕&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编译 .NET编译技术内幕(2)作者: builder.comTuesday, April 16 2002 12:23 PM 作为一种代码指令平台,Microsoft .NET比微软公司先前推出的其他技术平台要来得更为复杂.由于.NET提供了对多种编程语言以及(在理论上说)多重平台的支持,这就需要在传统的两个代码层添加一个中间代码层.在这里,传统的两层分别是源代码层和编译后的本机代码层.新加的代码层给.NET平台带来了额外的灵活性,不过,反过来却又增加了系统的复杂性.此外,由于这一新代码层的出现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balZ7Pz.html" rel="bookmark">WCF技术内幕</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;WCF技术内幕&gt;39:第2部分_第7章_通道管理器:通道工厂和本章 &lt;WCF技术内幕&gt;38:第2部分_第7章_通道管理器:通道侦听器 &lt;WCF技术内幕&gt;37:第2部分_第7章_通道管理器:概述和通道管理 &lt;WCF技术内幕&gt;36:第2部分_第6章_通道:创建自定义通道和本章 &lt;WCF技术内幕&gt;35:第2部分_第6章_通道:通道功能 &lt;WCF技术内幕&gt;34:第2部分_第6章_通道:通道接口和基本类型 &lt;WCF技术内幕&gt;33:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxoRrb.html" rel="bookmark">《WCF技术内幕》26</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;WCF技术内幕&gt;26:第2部分_第5章_消息:Buffered vs Streamed.序列化和反序列化消息 Buffered vs. Streamed消息 当我们在终结点之间流动的消息时,我们会本能地想到缓存.换个方式来说 ,我们假设程序接收到一个Message时,它已经知道整个Message.这种方式称作 缓存模式(buffering).与之相对的就是流处理模式(streaming),并且有2种 流处理模式(streaming).第一种是推模型(push model),发送者按照自己 的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKEq4p.html" rel="bookmark">《WCF技术内幕》23</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;WCF技术内幕&gt;23:第2部分_第5章_消息:XmlDictionaryReader和回到Message XmlDictionaryReader类型 XmlDictionaryReader抽象类型继承自System.Xml.XmlReader,因此继承了很 多XmlReader的特性.和XmlReader 一样,XmlDictionaryReader定义了几个工厂 方法,他们返回的是XmlDictionaryReader的子类型的实例.更确切地说, XmlDictionaryReader包装			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRrmYz.html" rel="bookmark">《WCF技术内幕》翻译15：第1部分&lowbar;第3章&lowbar;消息交换模式、拓扑与编排&colon;消息拓扑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;WCF技术内幕&gt;翻译15:第1部分_第3章_消息交换模式.拓扑与编排:消息拓扑.消息编排和本章小结 消息拓扑 消息拓扑描述的是在一个或多个发送者和接受者之间消息如何发送的.消息拓扑可以描述简单的应用-应用的连接关系,但是它同样可以描述复杂的应用-企业的连接.在后续文章里,面向服务的应用的作用会显现出来.概括地说,这些可能存在的拓扑结构比面向组件的应用系统能够涉及到的情况会更加多.更加复杂. 某种层次上,一个消息拓扑是一个或者多个消息交换模式(MEP)的组合.实际上可能存在有无数种拓扑结构,但			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK5EpN.html" rel="bookmark" class="title">PhotoShop把普通娃娃处理成精灵宝贝教程</a>
					<div>
						photoshop教程原图 效果 1.首先打开图片,把眼睛加大,按ctrl+shift+x进入液化 .2 这时候发现娃娃的脸很圆,再次进入液化状态,,选择向前变化工具一点点拉尖下巴 3.选择减淡工具涂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJAY2p.html" rel="bookmark" class="title">Android初学者，求解决这个URI解析</a>
					<div>
						问题描述 Android初学者,求解决这个URI解析 打印出来的信息是读取的同一张图片,选择图库里的就可以获取到,选择其他的就报null 解决方案 http://blog.csdn.net/ljz20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlV4Oz.html" rel="bookmark" class="title">发布开源前端类库 KISSY 1&period;1&period;0</a>
					<div>
						是否还记得,去年 10 月份的 美女与汽车 ? 眨眼近一年时光,KISSY 已经从一个开源编辑器的代号,演化成一个开源前端类库的名称. 愿景 KISSY 的愿景是:打造一个小巧灵活.简洁实用.使用起来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLWQLM.html" rel="bookmark" class="title">奇虎360能否挑战国内搜索引擎百度王者地位</a>
					<div>
						去年被炒的沸沸扬扬的3Q大战让人们对于国内的搜索引擎重新产生了新的认识,在奇虎360的挑动与百度.搜狗的参与下,上演了一场攻占与防守大戏,虽然没有按站长们期待的方向发展,却也让奇虎360的综合搜索受到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qba2JQM.html" rel="bookmark" class="title">360低调进入搜索领域&comma;高调调戏百度</a>
					<div>
						360做搜索引擎了?8月16日上线了新的产品--360综合搜索. 尽管360的综合搜索上线很是低调,但仍使得许多人为其疑问,为其好奇,让其高调的出现在网民眼前. 遥望十年前的互联网,百度与360为IE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBaZOz.html" rel="bookmark" class="title">网站因空间问题被关闭快照倒退的痛苦经历</a>
					<div>
						当大家都把目光都放在网站的SEO优化.外链.内容的更新方面,是否也考虑过本身网站所在的空间有一定的问题呢?以前刚学SEO的时候,经常听到大家说空间要稳定以及访问的速度.当时也认识到了这个问题的重要性, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPXD8z.html" rel="bookmark" class="title">在WPS快速制作田字格</a>
					<div>
						因学校举行书法比赛,所以需要绘制田字格,这个任务便落到了我这个&quot;电脑高手&quot;的头上,我选择的软件是WPS Office,想知道我是如何轻松完成的吗?来看看吧. 1.在&quot;页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6Q5Xz.html" rel="bookmark" class="title">Photoshop给婚纱照片合成梦幻的蝴蝶仙子效果</a>
					<div>
						  本教程主要使用Photoshop给婚纱照片合成梦幻的蝴蝶仙子效果,教程主要利用抠图.蒙版等技术合成复杂图像.为了让大家看到更清晰的操作,步骤可能有些多,只要耐心一定能学会. 最终效果图: 原图:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKxZZM.html" rel="bookmark" class="title">教你使用热点图优化网页设计</a>
					<div>
						  如果内容为王的话,那么设计就是城堡.对于企业而言,好的网页设计不仅包含了能够引起访客兴趣的内容,吸引目标用户,而且包含有直观而漂亮的UI设计,促进销售.许多设计师喜欢将自己认为创意爆棚的UI设计直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3K6AM.html" rel="bookmark" class="title">斯巴达Spartan浏览器怎么截图？</a>
					<div>
						  1.打开斯巴达Spartan浏览器然后在工具栏那个位置,就有一个截屏的图标,点击一下进入截图. 2.出来的工具有类似QQ截屏一样.只是功能没有那么多,依自己的需要去云截下来的图进行微调. 3.截好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwDAlb.html" rel="bookmark" class="title">Win8系统system&period;exe进程占用磁盘100&percnt;该怎么办</a>
					<div>
						  电脑在运行某些软件应用程序时会占用磁盘一定空间,比如说大家熟悉的win7纯净版,这就是所谓的软件运行越多,电脑就会变得越卡的原因.最近有用户在win8系统中通过任务管理器查看到system.exe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwEOnb.html" rel="bookmark" class="title">NetMeeting是什么？</a>
					<div>
						Netmeeting是Windows系统自带的网上聊天软件,意为&quot;网上会面&quot;. Netmeeting除了能够发送文字信息聊天之外,还可以配置麦克风.摄像头等仪器,进行语音.视频聊天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ol9Jb.html" rel="bookmark" class="title">win7系统装猎豹浏览器导致电脑蓝屏代码0x000000F4如何解决</a>
					<div>
						  电脑蓝屏0x000000F4原因分析:在配置为从属的硬盘上安装了Windows7操作系统并且没有其他设备连接到同一IDE 控制器通道(主要或辅助通道)时,该计算机上就会发生0x000000F4问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42Kv9M.html" rel="bookmark" class="title">冲裁模间隙对模具寿命的影响</a>
					<div>
						在冲裁模的设计中,凸凹模间隙的合理选取,是保证模具正常工作.提高冲片质量.延长模具寿命的一个关键因素.理想的间隙应该是板料冲裁断裂时,凸凹模刃口边所产生的裂纹在一条直线上,否则冲片边缘将出现不允许的毛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjdxQp.html" rel="bookmark" class="title">jquery基础总结</a>
					<div>
						什么是jQuery?        就是一个JavaScript函数库,开源的.jQuery能做什么        JavaScript是做什么的,jQuery就是做什么的,Jquery是对javas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwxqLM.html" rel="bookmark" class="title">&lbrack;转载&rsqb;Flash为客户端的多人网络游戏的实现</a>
					<div>
						多人网络游戏的实现 项目开发的基本硬件配置 一台普通的pc就可以了, 安装好windows 2000和vc6就可以了, 然后连上网,局域网和internet都可以, 接下去的东西我都简化,不去用晦涩的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRB3dz.html" rel="bookmark" class="title">Hostease美国主机提升综合竞争力满足国内市场</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 Hostease主机一直在国内市场占有很大的品牌知名度,他们一直在不断的提升产品的核心竞争力和科技创新.Hostease提升产品核心竞争力有以下几个方面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPwa1p.html" rel="bookmark" class="title">c语言-关于限定使用内存的排序</a>
					<div>
						问题描述 关于限定使用内存的排序 请问如何用C语言解决:文件A.txt存储了N个整数(N大于100万),要求仅占4k内存对它排序,结果输出到B.txt 解决方案 不用内存就用外部文件.参考:http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAy8JM.html" rel="bookmark" class="title">美国AutO-ID首先提出&OpenCurlyDoubleQuote;物联网&rdquo;概念</a>
					<div>
						1999年,美国AutO-ID首先提出&quot;物联网&quot;概念,主要是建立在物品编码.RFID技术和互联网的基础上. 2005年,国际电信联盟(ITU)发布的&lt;ITU互联网报告2005 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRnE6b.html" rel="bookmark" class="title">动软&period;net代码生成器 win2008 r2下无法连接oracle，以及vs2008模板丢失的解决</a>
					<div>
						一天之内遇到了二个奇怪的问题,人品值最近有所下降啊. 1.动软.Net代码生成器(就是园子里李天平的大作) 在win2008 r2下无法连接oracle数据库,而pl/sql developer.vs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyD9mz.html" rel="bookmark" class="title">如何使用 vs 来开发sharepoint的页面？？</a>
					<div>
						问题描述 类似于这种:http://www.shanghai-electric.com/Pages/Index.aspx路径是Pages/Index.aspx我在vs下创建的应用程序页的路径是_lay ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze02RVp.html" rel="bookmark" class="title">一个四年没维护的破网站 为何达成完美增长曲线？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 编者按:你能相信上面这份数据来自一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKLYlM.html" rel="bookmark" class="title">jQuery中的&period;bind&lpar;&rpar;、&period;live&lpar;&rpar;和&period;delegate&lpar;&rpar;之间区别分析&lowbar;jquery</a>
					<div>
						DOM树 首先,可视化一个HMTL文档的DOM树是很有帮助的.一个简单的HTML页面看起来就像是这个样子: 事件冒泡(又称事件传播) 当我们点击一个链接时,其触发了链接元素的单击事件,该事件则引发任何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmvAap.html" rel="bookmark" class="title">学习网页技术CSS样式表整理的6个技巧</a>
					<div>
						1. CSS字体属性简写规则 一般用CSS设定字体属性是这样做的: font-weight: bold; font-style: italic; font-varient: small-caps; f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXK6NWM.html" rel="bookmark" class="title">Photoshop制作两种超搞笑的表情包教程</a>
					<div>
						给各位photoshop软件的使用者们来详细的解析分享一下制作两种超搞笑的表情包的教程. 教程分享: 首先打开自己的ps软件,任意版本都可以,这里用的是cc版本.   接着打开准备好的图片.(暴走的表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW74KnM.html" rel="bookmark" class="title">美图秀秀眼睛放大怎么用 放大眼睛方法教程</a>
					<div>
						给各位美图秀秀软件的使用者们来详细的解析分享一下放大眼睛的使用方法. 方法分享: 1.打开要处理的照片,选择&quot;美容&quot;菜单下的&quot;眼睛放大&quot;功能.画笔力度不要太大, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QDRmp.html" rel="bookmark" class="title">这个程序哪错了了？？？？很急ji</a>
					<div>
						问题描述 #include&lt;stdio.h&gt;#include&lt;string.h&gt;structperson{charname[8];chartel[15];charqq[12]; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmZKAz.html" rel="bookmark" class="title">这两份offer选择哪一份好？有经验的能给个建议吗？</a>
					<div>
						问题描述 本人杭州工作两年(java开发),12年毕业,学校是211.985,软件工程专业,目前找的工作中有两份稍微好点的offer,大家给点建议,其他的offer就暂时不拿出来了.1.杭州海康威视, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn81lkb.html" rel="bookmark" class="title">MySQL的create table as 与 like区别&lpar;转&rpar;</a>
					<div>
						对于mysql的复制相同表结构方法,有create table as 和create table like 两种,区别是什么呢?     create table t2 as select * fro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1ADrb.html" rel="bookmark" class="title">visual studio-哪位写过利用VS和qt写出坐标轴，并可以画图的程序在？求助啊，很急，谢谢了</a>
					<div>
						问题描述 哪位写过利用VS和qt写出坐标轴,并可以画图的程序在?求助啊,很急,谢谢了 哪位写过利用VS和qt写出坐标轴,并可以画图的程序在?求助啊,很急,谢谢了					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
